2017-01-24 22:36:35 +00:00
#!/usr/bin/env bash
#------------------------------------------------------------------------------
# Bash script to run commandline Solidity tests.
#
# The documentation for solidity is hosted at:
#
2020-11-18 14:20:34 +00:00
# https://docs.soliditylang.org
2017-01-24 22:36:35 +00:00
#
# ------------------------------------------------------------------------------
# This file is part of solidity.
#
# solidity is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# solidity is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with solidity. If not, see <http://www.gnu.org/licenses/>
#
# (c) 2016 solidity contributors.
#------------------------------------------------------------------------------
2021-10-01 14:31:08 +00:00
set -eo pipefail
2017-01-24 22:36:35 +00:00
2018-12-20 11:17:33 +00:00
## GLOBAL VARIABLES
2020-12-11 17:19:53 +00:00
REPO_ROOT = $( cd " $( dirname " $0 " ) /.. " && pwd )
2020-04-17 13:02:40 +00:00
SOLIDITY_BUILD_DIR = ${ SOLIDITY_BUILD_DIR :- ${ REPO_ROOT } /build }
2020-12-12 00:46:21 +00:00
# shellcheck source=scripts/common.sh
2019-04-26 09:57:49 +00:00
source " ${ REPO_ROOT } /scripts/common.sh "
2020-12-12 00:46:21 +00:00
# shellcheck source=scripts/common_cmdline.sh
2020-01-28 15:34:38 +00:00
source " ${ REPO_ROOT } /scripts/common_cmdline.sh "
2020-02-11 00:47:57 +00:00
2021-09-15 13:30:40 +00:00
pushd " ${ REPO_ROOT } /test/cmdlineTests " > /dev/null
2021-09-10 19:05:17 +00:00
autoupdate = false
no_smt = false
declare -a selected_tests
2021-09-15 13:30:40 +00:00
declare -a patterns_with_no_matches
2021-09-10 19:05:17 +00:00
while [ [ $# -gt 0 ] ]
do
case " $1 " in
--update)
autoupdate = true
shift
; ;
--no-smt)
no_smt = true
shift
; ;
*)
2021-09-15 13:30:40 +00:00
matching_tests = $( find . -mindepth 1 -maxdepth 1 -type d -name " $1 " | cut --characters 3- | sort)
2021-09-17 18:54:01 +00:00
if [ [ $matching_tests = = "" ] ]
then
2021-09-15 13:30:40 +00:00
patterns_with_no_matches += ( " $1 " )
printWarning " No tests matching pattern ' $1 ' found. "
else
# shellcheck disable=SC2206 # We do not support test names containing spaces.
selected_tests += ( $matching_tests )
fi
2021-09-10 19:05:17 +00:00
shift
; ;
esac
done
2021-01-19 12:52:04 +00:00
2021-09-17 18:54:01 +00:00
if ( ( ${# selected_tests [@] } = = 0 && ${# patterns_with_no_matches [@] } = = 0 ) )
then
2021-09-15 13:30:40 +00:00
selected_tests = ( *)
fi
popd > /dev/null
2020-02-11 00:47:57 +00:00
case " $OSTYPE " in
msys)
2020-04-17 13:02:40 +00:00
SOLC = " ${ SOLIDITY_BUILD_DIR } /solc/Release/solc.exe "
2020-02-11 00:47:57 +00:00
# prevents msys2 path translation for a remapping test
export MSYS2_ARG_CONV_EXCL = "="
; ;
*)
2020-04-17 13:02:40 +00:00
SOLC = " ${ SOLIDITY_BUILD_DIR } /solc/solc "
2020-02-11 00:47:57 +00:00
; ;
esac
2021-09-15 13:31:20 +00:00
echo " Using solc binary at ${ SOLC } "
2020-02-11 00:47:57 +00:00
2019-04-15 21:51:31 +00:00
INTERACTIVE = true
if ! tty -s || [ " $CI " ]
then
2021-10-14 16:39:59 +00:00
INTERACTIVE = false
2019-04-15 21:51:31 +00:00
fi
2017-01-24 22:36:35 +00:00
2019-04-26 09:57:49 +00:00
# extend stack size in case we run via ASAN
2021-09-17 18:54:01 +00:00
if [ [ -n " ${ CIRCLECI } " ] ] || [ [ -n " $CI " ] ]
then
2019-04-26 09:57:49 +00:00
ulimit -s 16384
ulimit -a
2018-09-28 21:31:23 +00:00
fi
2017-10-05 18:46:38 +00:00
2019-04-26 09:57:49 +00:00
## FUNCTIONS
2017-10-05 18:46:38 +00:00
2021-01-19 12:52:04 +00:00
function update_expectation {
local newExpectation = " ${ 1 } "
local expectationFile = " ${ 2 } "
2021-08-30 17:22:28 +00:00
if [ [ $newExpectation = = "" || $newExpectation -eq 0 && $expectationFile = = */exit ] ]
then
if [ [ -f $expectationFile ] ]
then
rm " $expectationFile "
fi
return
fi
2021-01-19 12:52:04 +00:00
echo " $newExpectation " > " $expectationFile "
printLog " File $expectationFile updated to match the expectation. "
}
function ask_expectation_update
2019-04-07 16:24:14 +00:00
{
2021-10-14 16:39:59 +00:00
if [ [ $INTERACTIVE = = true ] ]
2019-04-15 21:51:31 +00:00
then
local newExpectation = " ${ 1 } "
local expectationFile = " ${ 2 } "
2021-01-19 12:52:04 +00:00
2021-09-10 19:05:17 +00:00
if [ [ $autoupdate = = true ] ]
2021-01-19 12:52:04 +00:00
then
update_expectation " $newExpectation " " $expectationFile "
else
2021-01-21 12:40:18 +00:00
local editor = " ${ FCEDIT :- ${ VISUAL :- ${ EDITOR :- vi } } } "
2021-01-19 12:52:04 +00:00
while true
do
2021-03-31 14:51:01 +00:00
read -r -n 1 -p "(e)dit/(u)pdate expectations/(s)kip/(q)uit? "
2021-01-19 12:52:04 +00:00
echo
case $REPLY in
2021-01-21 12:40:18 +00:00
e*) " $editor " " $expectationFile " ; break; ;
2021-01-19 12:52:04 +00:00
u*) update_expectation " $newExpectation " " $expectationFile " ; break; ;
2021-01-21 12:40:18 +00:00
s*) return ; ;
2021-10-14 16:39:59 +00:00
q*) fail; ;
2021-01-19 12:52:04 +00:00
esac
done
fi
2019-06-12 17:03:45 +00:00
else
2021-10-14 16:39:59 +00:00
[ [ $INTERACTIVE = = false ] ] || assertFail
fail
2019-04-15 21:51:31 +00:00
fi
2019-04-07 16:24:14 +00:00
}
2018-08-06 16:52:49 +00:00
# General helper function for testing SOLC behaviour, based on file name, compile opts, exit code, stdout and stderr.
# An failure is expected.
2018-12-20 11:08:42 +00:00
function test_solc_behaviour( )
{
2018-08-06 16:52:49 +00:00
local filename = " ${ 1 } "
2020-12-11 20:34:55 +00:00
local solc_args
IFS = " " read -r -a solc_args <<< " ${ 2 } "
2018-12-11 14:47:19 +00:00
local solc_stdin = " ${ 3 } "
2019-04-16 13:17:33 +00:00
[ -z " $solc_stdin " ] && solc_stdin = "/dev/stdin"
2018-12-11 14:47:19 +00:00
local stdout_expected = " ${ 4 } "
local exit_code_expected = " ${ 5 } "
2021-01-21 13:00:38 +00:00
local exit_code_expectation_file = " ${ 6 } "
local stderr_expected = " ${ 7 } "
local stdout_expectation_file = " ${ 8 } " # the file to write to when user chooses to update stdout expectation
local stderr_expectation_file = " ${ 9 } " # the file to write to when user chooses to update stderr expectation
2020-12-11 17:26:47 +00:00
local stdout_path; stdout_path = $( mktemp)
local stderr_path; stderr_path = $( mktemp)
2019-04-07 16:24:14 +00:00
2020-12-11 17:28:19 +00:00
# shellcheck disable=SC2064
2019-04-07 16:24:14 +00:00
trap " rm -f $stdout_path $stderr_path " EXIT
2021-09-17 18:54:01 +00:00
if [ [ " $exit_code_expected " = "" ] ]
then
exit_code_expected = "0"
fi
2018-08-06 16:52:49 +00:00
2021-04-10 20:24:05 +00:00
[ [ $filename = = "" ] ] || solc_args += ( " $filename " )
local solc_command = " $SOLC ${ solc_args [*] } < $solc_stdin "
2018-08-06 16:52:49 +00:00
set +e
2021-04-10 20:24:05 +00:00
" $SOLC " " ${ solc_args [@] } " <" $solc_stdin " >" $stdout_path " 2>" $stderr_path "
2018-08-06 16:52:49 +00:00
exitCode = $?
set -e
2020-12-11 20:34:55 +00:00
if [ [ " ${ solc_args [*] } " = = *" --standard-json " * ] ]
2018-12-20 11:08:42 +00:00
then
2021-07-07 11:18:24 +00:00
python3 - <<EOF
import re, sys
json = open( " $stdout_path " , "r" ) .read( )
json = re.sub( r"{[^{}]*Warning: This is a pre-release compiler version[^{}]*},?" , "" , json)
json = re.sub( r"},\s*]" , "}]" , json) # },] -> }]
json = re.sub( r"\"errors\":\s*\[\s*\],?\s*" ,"" ,json) # Remove "errors" array if it's not empty
json = re.sub( "\n\\s+\n" , "\n\n" , json) # Remove any leftover trailing whitespace
open( " $stdout_path " , "w" ) .write( json)
EOF
2019-08-12 15:23:38 +00:00
sed -i.bak -E -e 's/ Consider adding \\"pragma solidity \^[0-9.]*;\\"//g' " $stdout_path "
2020-11-05 16:57:46 +00:00
sed -i.bak -E -e 's/\"opcodes\":\"[^"]+\"/\"opcodes\":\"<OPCODES REMOVED>\"/g' " $stdout_path "
sed -i.bak -E -e 's/\"sourceMap\":\"[0-9:;-]+\"/\"sourceMap\":\"<SOURCEMAP REMOVED>\"/g' " $stdout_path "
2020-11-04 18:34:53 +00:00
# Remove bytecode (but not linker references).
sed -i.bak -E -e 's/(\"object\":\")[0-9a-f]+([^"]*\")/\1<BYTECODE REMOVED>\2/g' " $stdout_path "
2020-12-11 17:28:19 +00:00
# shellcheck disable=SC2016
2020-11-04 18:34:53 +00:00
sed -i.bak -E -e 's/(\"object\":\"[^"]+\$__)[0-9a-f]+(\")/\1<BYTECODE REMOVED>\2/g' " $stdout_path "
2020-12-11 17:28:19 +00:00
# shellcheck disable=SC2016
2020-11-13 22:37:29 +00:00
sed -i.bak -E -e 's/([0-9a-f]{34}\$__)[0-9a-f]+(__\$[0-9a-f]{17})/\1<BYTECODE REMOVED>\2/g' " $stdout_path "
2021-06-08 14:35:37 +00:00
# Remove metadata in assembly output (see below about the magic numbers)
sed -i.bak -E -e 's/"[0-9a-f]+64697066735822[0-9a-f]+64736f6c63[0-9a-f]+/"<BYTECODE REMOVED>/g' " $stdout_path "
# Remove hash of text representation in ewasm
sed -i.bak -E -e 's/The Keccak-256 hash of the text representation of .*: [0-9a-f]+/The Keccak-256 hash of the text representation of <REMOVED>/g' " $stdout_path "
2020-11-04 18:34:53 +00:00
2019-07-03 07:59:36 +00:00
# Replace escaped newlines by actual newlines for readability
2020-12-11 17:28:19 +00:00
# shellcheck disable=SC1003
2019-07-03 07:59:36 +00:00
sed -i.bak -E -e 's/\\n/\' $'\n/g' " $stdout_path "
2021-07-13 14:06:07 +00:00
sed -i.bak -e 's/\(^[ ]*auxdata: \)0x[0-9a-f]*$/\1<AUXDATA REMOVED>/' " $stdout_path "
2019-07-03 09:26:28 +00:00
rm " $stdout_path .bak "
2018-12-13 12:31:12 +00:00
else
2019-09-06 12:19:49 +00:00
sed -i.bak -e '/^Warning: This is a pre-release compiler version, please do not use it in production./d' " $stderr_path "
2021-08-05 15:11:58 +00:00
sed -i.bak -e '/^Compiler run successful, no output requested\.$/d' " $stderr_path "
2020-06-04 01:19:47 +00:00
sed -i.bak -e '/^Warning (3805): This is a pre-release compiler version, please do not use it in production./d' " $stderr_path "
2020-11-05 16:57:46 +00:00
sed -i.bak -e 's/\(^[ ]*auxdata: \)0x[0-9a-f]*$/\1<AUXDATA REMOVED>/' " $stdout_path "
2019-09-06 12:19:49 +00:00
sed -i.bak -e 's/ Consider adding "pragma .*$//' " $stderr_path "
2020-11-12 10:54:37 +00:00
sed -i.bak -e 's/\(Unimplemented feature error.* in \).*$/\1<FILENAME REMOVED>/' " $stderr_path "
2021-04-10 19:11:44 +00:00
sed -i.bak -e 's/"version":[ ]*"[^"]*"/"version": "<VERSION REMOVED>"/' " $stdout_path "
2020-11-04 18:34:53 +00:00
# Remove bytecode (but not linker references). Since non-JSON output is unstructured,
# use metadata markers for detection to have some confidence that it's actually bytecode
# and not some random word.
# 64697066735822 = hex encoding of 0x64 'i' 'p' 'f' 's' 0x58 0x22
# 64736f6c63 = hex encoding of 0x64 's' 'o' 'l' 'c'
sed -i.bak -E -e 's/[0-9a-f]*64697066735822[0-9a-f]+64736f6c63[0-9a-f]+/<BYTECODE REMOVED>/g' " $stdout_path "
2020-12-11 17:28:19 +00:00
# shellcheck disable=SC2016
2020-11-13 22:37:29 +00:00
sed -i.bak -E -e 's/([0-9a-f]{17}\$__)[0-9a-f]+(__\$[0-9a-f]{17})/\1<BYTECODE REMOVED>\2/g' " $stdout_path "
2020-12-11 17:28:19 +00:00
# shellcheck disable=SC2016
2020-11-04 18:34:53 +00:00
sed -i.bak -E -e 's/[0-9a-f]+((__\$[0-9a-f]{34}\$__)*<BYTECODE REMOVED>)/<BYTECODE REMOVED>\1/g' " $stdout_path "
2019-09-06 09:52:58 +00:00
# Remove trailing empty lines. Needs a line break to make OSX sed happy.
2019-09-06 12:19:49 +00:00
sed -i.bak -e ' 1{ /^$/d
2019-09-06 09:52:58 +00:00
} ' " $stderr_path "
2020-04-24 08:30:19 +00:00
rm " $stderr_path .bak " " $stdout_path .bak "
2018-12-13 12:31:12 +00:00
fi
2019-03-11 16:30:46 +00:00
# Remove path to cpp file
2019-09-06 12:19:49 +00:00
sed -i.bak -e 's/^\(Exception while assembling:\).*/\1/' " $stderr_path "
2019-03-21 16:17:42 +00:00
# Remove exception class name.
2019-09-06 12:19:49 +00:00
sed -i.bak -e 's/^\(Dynamic exception type:\).*/\1/' " $stderr_path "
rm " $stderr_path .bak "
2018-09-10 19:22:13 +00:00
2018-12-20 11:08:42 +00:00
if [ [ $exitCode -ne " $exit_code_expected " ] ]
then
2018-12-06 11:31:27 +00:00
printError " Incorrect exit code. Expected $exit_code_expected but got $exitCode . "
2021-01-21 13:00:38 +00:00
2021-04-10 20:58:49 +00:00
[ [ $exit_code_expectation_file != "" ] ] && ask_expectation_update " $exitCode " " $exit_code_expectation_file "
2021-10-14 16:39:59 +00:00
[ [ $exit_code_expectation_file = = "" ] ] && fail
2018-08-06 16:52:49 +00:00
fi
2020-12-11 17:19:53 +00:00
if [ [ " $( cat " $stdout_path " ) " != " ${ stdout_expected } " ] ]
2018-12-20 11:08:42 +00:00
then
2018-12-06 11:31:27 +00:00
printError "Incorrect output on stdout received. Expected:"
2019-04-15 21:51:31 +00:00
echo -e " ${ stdout_expected } "
2018-08-06 16:52:49 +00:00
printError "But got:"
2020-12-11 17:19:53 +00:00
echo -e " $( cat " $stdout_path " ) "
2018-12-20 11:52:14 +00:00
2019-04-07 16:24:14 +00:00
printError " When running $solc_command "
2021-01-21 13:00:38 +00:00
[ [ $stdout_expectation_file != "" ] ] && ask_expectation_update " $( cat " $stdout_path " ) " " $stdout_expectation_file "
2021-10-14 16:39:59 +00:00
[ [ $stdout_expectation_file = = "" ] ] && fail
2018-08-06 16:52:49 +00:00
fi
2020-12-11 17:19:53 +00:00
if [ [ " $( cat " $stderr_path " ) " != " ${ stderr_expected } " ] ]
2018-12-20 11:08:42 +00:00
then
2018-08-06 16:52:49 +00:00
printError "Incorrect output on stderr received. Expected:"
2019-04-15 21:51:31 +00:00
echo -e " ${ stderr_expected } "
2018-08-06 16:52:49 +00:00
printError "But got:"
2020-12-11 17:19:53 +00:00
echo -e " $( cat " $stderr_path " ) "
2018-12-20 11:52:14 +00:00
2019-04-07 16:24:14 +00:00
printError " When running $solc_command "
2018-08-06 16:52:49 +00:00
2021-01-21 13:00:38 +00:00
[ [ $stderr_expectation_file != "" ] ] && ask_expectation_update " $( cat " $stderr_path " ) " " $stderr_expectation_file "
2021-10-14 16:39:59 +00:00
[ [ $stderr_expectation_file = = "" ] ] && fail
2019-04-07 16:24:14 +00:00
fi
2020-04-24 08:30:19 +00:00
2021-10-01 15:17:51 +00:00
rm " $stdout_path " " $stderr_path "
2018-08-06 16:52:49 +00:00
}
2018-12-20 11:17:33 +00:00
function test_solc_assembly_output( )
{
local input = " ${ 1 } "
local expected = " ${ 2 } "
2020-12-11 20:34:55 +00:00
IFS = " " read -r -a solc_args <<< " ${ 3 } "
2018-12-20 11:17:33 +00:00
2020-12-11 17:19:53 +00:00
local expected_object = " object \"object\" { code ${ expected } } "
2018-12-20 11:17:33 +00:00
2021-10-01 15:27:09 +00:00
output = $( echo " ${ input } " | msg_on_error --no-stderr " $SOLC " - " ${ solc_args [@] } " )
2020-12-12 04:40:20 +00:00
empty = $( echo " $output " | tr '\n' ' ' | tr -s ' ' | sed -ne " / ${ expected_object } /p " )
2018-12-20 11:17:33 +00:00
if [ -z " $empty " ]
then
printError "Incorrect assembly output. Expected: "
2021-10-14 16:39:59 +00:00
>& 2 echo -e " ${ expected } "
2020-12-11 20:34:55 +00:00
printError " with arguments ${ solc_args [*] } , but got: "
2021-10-14 16:39:59 +00:00
>& 2 echo " ${ output } "
fail
2018-12-20 11:17:33 +00:00
fi
}
## RUN
echo "Checking that the bug list is up to date..."
" $REPO_ROOT " /scripts/update_bugs_by_version.py
printTask "Testing unknown options..."
(
set +e
output = $( " $SOLC " --allow= test 2>& 1)
failed = $?
set -e
if [ " $output " = = "unrecognised option '--allow=test'" ] && [ $failed -ne 0 ]
then
echo "Passed"
else
2021-10-01 15:21:11 +00:00
fail " Incorrect response to unknown options: $output "
2018-12-20 11:17:33 +00:00
fi
)
2018-08-06 16:52:49 +00:00
printTask "Testing passing files that are not found..."
2021-01-21 13:00:38 +00:00
test_solc_behaviour "file_not_found.sol" "" "" "" 1 "" "\"file_not_found.sol\" is not found." "" ""
2018-08-06 16:52:49 +00:00
printTask "Testing passing files that are not files..."
2021-01-21 13:00:38 +00:00
test_solc_behaviour "." "" "" "" 1 "" "\".\" is not a valid file." "" ""
2018-08-06 16:52:49 +00:00
2018-08-09 18:37:49 +00:00
printTask "Testing passing empty remappings..."
2021-01-21 13:00:38 +00:00
test_solc_behaviour " ${ 0 } " "=/some/remapping/target" "" "" 1 "" "Invalid remapping: \"=/some/remapping/target\"." "" ""
test_solc_behaviour " ${ 0 } " "ctx:=/some/remapping/target" "" "" 1 "" "Invalid remapping: \"ctx:=/some/remapping/target\"." "" ""
2018-12-11 14:47:19 +00:00
2018-12-06 11:31:27 +00:00
printTask "Running general commandline tests..."
2018-09-10 19:22:13 +00:00
(
2018-12-20 11:32:53 +00:00
cd " $REPO_ROOT " /test/cmdlineTests/
2021-09-10 19:05:17 +00:00
for tdir in " ${ selected_tests [@] } "
2018-12-20 11:08:42 +00:00
do
2021-09-17 18:54:01 +00:00
if ! [ [ -d $tdir ] ]
then
2021-10-01 15:21:11 +00:00
fail " Test directory not found: $tdir "
2021-07-27 23:02:13 +00:00
fi
2020-11-07 15:12:11 +00:00
printTask " - ${ tdir } "
2021-09-17 18:54:01 +00:00
if [ [ $( ls -A " $tdir " ) = = "" ] ]
then
printWarning " ---> skipped (test dir empty)"
continue
fi
2020-11-10 14:59:14 +00:00
# Strip trailing slash from $tdir.
2020-11-07 15:15:04 +00:00
tdir = $( basename " ${ tdir } " )
2021-09-10 19:05:17 +00:00
if [ [ $no_smt = = true ] ]
then
2021-09-17 18:54:01 +00:00
if [ [ $tdir = ~ .*model_checker_.* ] ]
then
printWarning " ---> skipped (SMT test)"
2021-09-10 19:05:17 +00:00
continue
fi
fi
2020-11-07 15:15:04 +00:00
2020-12-11 17:19:53 +00:00
inputFiles = " $( ls -1 " ${ tdir } /input. " * 2> /dev/null || true ) "
inputCount = " $( echo " ${ inputFiles } " | wc -w) "
2020-12-11 19:01:09 +00:00
if ( ( inputCount > 1 ) )
2018-12-20 11:32:53 +00:00
then
2020-11-07 15:16:53 +00:00
printError "Ambiguous input. Found input files in multiple formats:"
echo -e " ${ inputFiles } "
2021-10-14 16:39:59 +00:00
fail
2020-11-07 15:16:53 +00:00
fi
# Use printf to get rid of the trailing newline
inputFile = $( printf "%s" " ${ inputFiles } " )
if [ " ${ inputFile } " = " ${ tdir } /input.json " ]
then
2021-10-01 15:21:11 +00:00
! [ -e " ${ tdir } /stdin " ] || fail "Found a file called 'stdin' but redirecting standard input in JSON mode is not allowed."
2021-04-10 19:56:22 +00:00
2020-11-07 15:16:53 +00:00
stdin = " ${ inputFile } "
2018-12-20 11:32:53 +00:00
inputFile = ""
2020-12-11 17:19:53 +00:00
stdout = " $( cat " ${ tdir } /output.json " 2>/dev/null || true ) "
2019-04-16 12:43:32 +00:00
stdoutExpectationFile = " ${ tdir } /output.json "
2020-12-11 20:34:55 +00:00
command_args = "--standard-json " $( cat " ${ tdir } /args " 2>/dev/null || true )
2018-12-20 11:32:53 +00:00
else
2021-04-10 19:56:22 +00:00
if [ -e " ${ tdir } /stdin " ]
then
stdin = " ${ tdir } /stdin "
2021-10-01 15:21:11 +00:00
[ -f " ${ tdir } /stdin " ] || fail "'stdin' is not a regular file."
2021-04-10 19:56:22 +00:00
else
stdin = ""
fi
2020-12-11 17:19:53 +00:00
stdout = " $( cat " ${ tdir } /output " 2>/dev/null || true ) "
2019-04-16 12:43:32 +00:00
stdoutExpectationFile = " ${ tdir } /output "
2020-12-11 20:34:55 +00:00
command_args = $( cat " ${ tdir } /args " 2>/dev/null || true )
2018-12-20 11:32:53 +00:00
fi
2021-01-21 13:00:38 +00:00
exitCodeExpectationFile = " ${ tdir } /exit "
exitCode = $( cat " $exitCodeExpectationFile " 2>/dev/null || true )
2020-12-11 17:19:53 +00:00
err = " $( cat " ${ tdir } /err " 2>/dev/null || true ) "
2019-04-07 16:24:14 +00:00
stderrExpectationFile = " ${ tdir } /err "
test_solc_behaviour " $inputFile " \
2020-12-11 20:34:55 +00:00
" $command_args " \
2019-04-07 16:24:14 +00:00
" $stdin " \
" $stdout " \
" $exitCode " \
2021-01-21 13:00:38 +00:00
" $exitCodeExpectationFile " \
2019-04-07 16:24:14 +00:00
" $err " \
" $stdoutExpectationFile " \
" $stderrExpectationFile "
2018-12-20 11:08:42 +00:00
done
2018-09-10 19:22:13 +00:00
)
2017-10-05 18:46:38 +00:00
printTask "Compiling various other contracts and libraries..."
2017-07-12 17:06:36 +00:00
(
2018-12-20 11:08:42 +00:00
cd " $REPO_ROOT " /test/compilationTests/
2018-12-20 11:12:53 +00:00
for dir in */
2018-12-20 11:08:42 +00:00
do
2018-12-20 11:12:53 +00:00
echo " - $dir "
cd " $dir "
2021-10-06 16:32:06 +00:00
# shellcheck disable=SC2046 # These file names are not supposed to contain spaces.
compileFull --expect-warnings $( find . -name '*.sol' )
2018-12-20 11:12:53 +00:00
cd ..
2018-12-20 11:08:42 +00:00
done
2017-07-12 17:06:36 +00:00
)
2017-10-05 18:46:38 +00:00
printTask "Compiling all examples from the documentation..."
2018-09-03 10:54:29 +00:00
SOLTMPDIR = $( mktemp -d)
2017-07-10 21:53:31 +00:00
(
set -e
2018-09-03 10:54:29 +00:00
cd " $SOLTMPDIR "
2021-07-01 13:19:38 +00:00
" $REPO_ROOT " /scripts/isolate_tests.py " $REPO_ROOT " /docs/
2021-03-25 11:31:34 +00:00
developmentVersion = $( " $REPO_ROOT /scripts/get_version.sh " )
2019-08-05 11:00:30 +00:00
2021-07-05 17:38:41 +00:00
for f in *.yul *.sol
2017-07-10 21:53:31 +00:00
do
2018-08-09 18:48:41 +00:00
# The contributors guide uses syntax tests, but we cannot
# really handle them here.
if grep -E 'DeclarationError:|// ----' " $f " >/dev/null
then
continue
fi
2017-07-12 17:06:36 +00:00
echo " $f "
2019-08-05 11:00:30 +00:00
2020-12-11 20:34:55 +00:00
opts = ( )
2018-08-09 18:48:41 +00:00
# We expect errors if explicitly stated, or if imports
# are used (in the style guide)
if grep -E "This will not compile|import \"" " $f " >/dev/null
2018-08-09 12:58:28 +00:00
then
2021-07-12 14:31:29 +00:00
opts = ( --expect-errors)
2018-08-09 12:58:28 +00:00
fi
if grep "This will report a warning" " $f " >/dev/null
then
2021-07-12 14:31:29 +00:00
opts += ( --expect-warnings)
2018-08-09 12:58:28 +00:00
fi
2020-03-10 12:21:25 +00:00
if grep "This may report a warning" " $f " >/dev/null
then
2021-07-12 14:31:29 +00:00
opts += ( --ignore-warnings)
2020-03-10 12:21:25 +00:00
fi
2021-03-25 11:31:34 +00:00
# Disable the version pragma in code snippets that only work with the current development version.
# It's necessary because x.y.z won't match `^x.y.z` or `>=x.y.z` pragmas until it's officially released.
sed -i.bak -E -e 's/pragma[[:space:]]+solidity[[:space:]]*(\^|>=)[[:space:]]*' " $developmentVersion " '/pragma solidity >0.0.1/' " $f "
2020-12-11 20:34:55 +00:00
compileFull " ${ opts [@] } " " $SOLTMPDIR / $f "
2017-07-10 21:53:31 +00:00
done
)
2021-10-01 15:17:51 +00:00
rm -r " $SOLTMPDIR "
2017-07-10 21:53:31 +00:00
echo "Done."
2017-10-05 18:46:38 +00:00
printTask "Testing library checksum..."
2021-10-01 15:27:09 +00:00
echo '' | msg_on_error --no-stdout " $SOLC " - --link --libraries a = 0x90f20564390eAe531E810af625A22f51385Cd222
2021-10-14 16:39:59 +00:00
echo '' | " $SOLC " - --link --libraries a = 0x80f20564390eAe531E810af625A22f51385Cd222 & >/dev/null && \
fail "solc --link did not reject a library address with an invalid checksum."
2017-02-16 16:13:55 +00:00
2017-10-05 18:46:38 +00:00
printTask "Testing long library names..."
2021-10-01 15:27:09 +00:00
echo '' | msg_on_error --no-stdout " $SOLC " - --link --libraries aveeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeerylonglibraryname = 0x90f20564390eAe531E810af625A22f51385Cd222
2017-03-14 10:58:43 +00:00
2018-10-04 12:55:02 +00:00
printTask "Testing linking itself..."
SOLTMPDIR = $( mktemp -d)
(
cd " $SOLTMPDIR "
echo 'library L { function f() public pure {} } contract C { function f() public pure { L.f(); } }' > x.sol
2021-10-01 15:27:09 +00:00
msg_on_error --no-stderr " $SOLC " --bin -o . x.sol
2018-10-04 12:55:02 +00:00
# Explanation and placeholder should be there
grep -q '//' C.bin && grep -q '__' C.bin
# But not in library file.
grep -q -v '[/_]' L.bin
# Now link
2021-10-01 15:27:09 +00:00
msg_on_error " $SOLC " --link --libraries x.sol:L= 0x90f20564390eAe531E810af625A22f51385Cd222 C.bin
2018-10-04 12:55:02 +00:00
# Now the placeholder and explanation should be gone.
grep -q -v '[/_]' C.bin
)
2021-10-01 15:17:51 +00:00
rm -r " $SOLTMPDIR "
2018-10-04 12:55:02 +00:00
2018-04-24 13:18:12 +00:00
printTask "Testing overwriting files..."
2018-09-03 10:54:29 +00:00
SOLTMPDIR = $( mktemp -d)
2017-03-10 18:10:47 +00:00
(
# First time it works
2021-10-01 15:27:09 +00:00
echo 'contract C {}' | msg_on_error --no-stderr " $SOLC " - --bin -o " $SOLTMPDIR /non-existing-stuff-to-create "
2017-03-10 18:10:47 +00:00
# Second time it fails
2021-10-14 16:39:59 +00:00
echo 'contract C {}' | " $SOLC " - --bin -o " $SOLTMPDIR /non-existing-stuff-to-create " 2>/dev/null && \
fail " solc did not refuse to overwrite $SOLTMPDIR /non-existing-stuff-to-create. "
2017-03-10 18:10:47 +00:00
# Unless we force
2021-10-01 15:27:09 +00:00
echo 'contract C {}' | msg_on_error --no-stderr " $SOLC " - --overwrite --bin -o " $SOLTMPDIR /non-existing-stuff-to-create "
2017-03-10 18:10:47 +00:00
)
2021-10-01 15:17:51 +00:00
rm -r " $SOLTMPDIR "
2017-03-10 18:10:47 +00:00
2018-11-21 17:10:56 +00:00
printTask "Testing assemble, yul, strict-assembly and optimize..."
(
2021-10-01 15:27:09 +00:00
echo '{}' | msg_on_error --silent " $SOLC " - --assemble
echo '{}' | msg_on_error --silent " $SOLC " - --yul
echo '{}' | msg_on_error --silent " $SOLC " - --strict-assembly
2018-11-21 17:10:56 +00:00
# Test options above in conjunction with --optimize.
# Using both, --assemble and --optimize should fail.
2021-10-14 16:39:59 +00:00
echo '{}' | " $SOLC " - --assemble --optimize & >/dev/null && fail "solc --assemble --optimize did not fail as expected."
echo '{}' | " $SOLC " - --yul --optimize & >/dev/null && fail "solc --yul --optimize did not fail as expected."
2018-11-29 14:56:51 +00:00
# Test yul and strict assembly output
# Non-empty code results in non-empty binary representation with optimizations turned off,
# while it results in empty binary representation with optimizations turned on.
2020-01-29 18:10:53 +00:00
test_solc_assembly_output "{ let x:u256 := 0:u256 }" "{ let x := 0 }" "--yul"
test_solc_assembly_output "{ let x:u256 := bitnot(7:u256) }" "{ let x := bitnot(7) }" "--yul"
test_solc_assembly_output "{ let t:bool := not(true) }" "{ let t:bool := not(true) }" "--yul"
2018-11-29 14:56:51 +00:00
test_solc_assembly_output "{ let x := 0 }" "{ let x := 0 }" "--strict-assembly"
2019-04-04 15:48:29 +00:00
test_solc_assembly_output "{ let x := 0 }" "{ { } }" "--strict-assembly --optimize"
2018-11-21 17:10:56 +00:00
)
2018-04-24 13:18:12 +00:00
printTask "Testing standard input..."
2018-09-03 10:54:29 +00:00
SOLTMPDIR = $( mktemp -d)
2018-04-24 13:18:12 +00:00
(
set +e
2021-10-01 15:18:41 +00:00
output = $( " $SOLC " --bin 2>& 1)
2018-04-24 13:18:12 +00:00
result = $?
set -e
# This should fail
2020-12-11 19:31:26 +00:00
if [ [ ! ( " $output " = ~ "No input files given" ) || ( $result = = 0) ] ]
2018-12-20 11:08:42 +00:00
then
2021-10-01 15:21:11 +00:00
fail " Incorrect response to empty input arg list: $output "
2018-04-24 13:18:12 +00:00
fi
# The contract should be compiled
2021-10-01 15:27:09 +00:00
if ! echo 'contract C {}' | msg_on_error --no-stderr " $SOLC " - --bin | grep -q "<stdin>:C"
2018-12-20 11:08:42 +00:00
then
2021-10-01 15:21:11 +00:00
fail "Failed to compile a simple contract from standard input"
2018-04-24 13:18:12 +00:00
fi
2018-10-15 15:54:48 +00:00
# This should not fail
2021-10-01 15:27:09 +00:00
echo '' | msg_on_error --silent --msg "Incorrect response to --ast-compact-json option with empty stdin" \
" $SOLC " --ast-compact-json -
2018-04-24 13:18:12 +00:00
)
2021-10-01 15:18:41 +00:00
rm -r " $SOLTMPDIR "
2018-04-24 13:18:12 +00:00
2019-09-11 19:16:35 +00:00
printTask "Testing AST import..."
SOLTMPDIR = $( mktemp -d)
(
cd " $SOLTMPDIR "
2020-12-12 02:01:48 +00:00
if ! " $REPO_ROOT /scripts/ASTImportTest.sh "
2019-09-11 19:16:35 +00:00
then
2021-10-14 16:39:59 +00:00
rm -r " $SOLTMPDIR "
fail
2019-09-11 19:16:35 +00:00
fi
)
2021-10-01 15:17:51 +00:00
rm -r " $SOLTMPDIR "
2019-09-11 19:16:35 +00:00
2020-07-08 20:08:50 +00:00
printTask "Testing AST export with stop-after=parsing..."
" $REPO_ROOT /test/stopAfterParseTests.sh "
2017-10-05 18:46:38 +00:00
printTask "Testing soljson via the fuzzer..."
2018-09-03 10:54:29 +00:00
SOLTMPDIR = $( mktemp -d)
2017-02-16 16:13:55 +00:00
(
2017-03-10 18:10:47 +00:00
set -e
2018-09-03 10:54:29 +00:00
cd " $SOLTMPDIR "
2017-03-22 19:19:20 +00:00
" $REPO_ROOT " /scripts/isolate_tests.py " $REPO_ROOT " /test/
2021-07-01 13:19:38 +00:00
" $REPO_ROOT " /scripts/isolate_tests.py " $REPO_ROOT " /docs/
2017-08-30 23:24:25 +00:00
2020-12-12 01:59:25 +00:00
echo ./*.sol | xargs -P 4 -n 50 " ${ SOLIDITY_BUILD_DIR } /test/tools/solfuzzer " --quiet --input-files
echo ./*.sol | xargs -P 4 -n 50 " ${ SOLIDITY_BUILD_DIR } /test/tools/solfuzzer " --without-optimizer --quiet --input-files
2017-02-16 16:13:55 +00:00
)
2021-10-01 15:17:51 +00:00
rm -r " $SOLTMPDIR "
2018-12-20 11:17:33 +00:00
2018-02-26 19:41:18 +00:00
echo "Commandline tests successful."